import Sudoku(solve)

import Control.Parallel
import Control.DeepSeq
import Data.Maybe (isJust) 

import System.Process(system)

f = "sudoku17.1000.txt" -- 1000 minimalist sudokus

main :: IO ()
main = do
    grids <- fmap lines $ readFile f
    let (as,bs) = splitAt (length grids `div` 2) grids
        as' = deep $ map solve as
        bs' = deep $ map solve bs
        solutions = bs' `par` as' `pseq` (as'++bs')
    print $ all isJust solutions

deep :: NFData a => a -> a
deep a = a `deepseq` a






--------
threaded = True
cogo n = do -- compile and run (normally: use a Makefile!)
     let file     = "sudoku" ++ show n
         (tC,tRT) = if threaded then 
                       (" -threaded -eventlog ", " -ls -N2")
                       else ("","") 
         ghcOPTS  = " -O2 -rtsopts " ++ tC 
         rtFlags  = " +RTS -s" ++ tRT

     system ("ghc" ++ ghcOPTS ++ file)   
     system ("./"++file ++ rtFlags )
     if threaded 
       then system ("threadscope "++ file ++".eventlog ")     
       else system "exit 0"